/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.mandant.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="MANDANT.UK",
     query="SELECT o FROM Mandant o WHERE "

                         + "o"
                +".nummer"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="MANDANT.All",
     query="SELECT o FROM Mandant o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="MANDANT.Nummer",
     query="SELECT o FROM Mandant o WHERE o.nummer=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "MANDANT")
// @javax.persistence.IdClass(MandantPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Mandant
extends AbstractMandant
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Mandant() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Mandant(Mandant original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "mandant_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Mandant")
    @javax.persistence.TableGenerator(name = "Mandant", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Mandant", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient MandantPK pkCache;

  @Override
  public MandantPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new MandantPK(getId());
    }

    return pkCache;
  }

  public static <E extends Mandant> java.util.Map<MandantPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<MandantPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Mandant> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedArt = false;
          hasChangedBeschreibung = false;
          hasChangedName = false;
          hasChangedNummer = false;
          hasChangedStatus = false;
          hasChangedSystemGebietsebene = false;
          hasChangedVerantworteteGebiete = false;
  


                                                                                                        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ART", nullable = MandantConstants.ART_NULLABLE)
    
  protected de.ivu.elect.business.mandant.entity.MandantArt art =  null;

  @javax.persistence.Transient
  protected boolean hasChangedArt = false;

  public boolean hasChangedArt(){
    return hasChangedArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.mandant.entity.MandantArt wertNachLadenArt;
  
  /**
   * 
   *
   * getter for MANDANT.ART
   */
    @Override   public  de.ivu.elect.business.mandant.entity.MandantArt getArt() {
        return art;
      }

  /**
   * 
   *
   * setter for MANDANT.ART
   *
   * @param art
   */
  @Override   public void setArt( de.ivu.elect.business.mandant.entity.MandantArt art) {

       resetTkCache();
                  de.ivu.elect.business.mandant.entity.MandantArt artInternal = art;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.art
      , artInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("art");
      }


             if (!isSeitLadenVeraendertArt) {
          isSeitLadenVeraendertArt = thisAttributChanged;
         if (isSeitLadenVeraendertArt){
           wertNachLadenArt=this.art;
         }
       }
      

       this.art = artInternal;

         }

        
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = MandantConstants.BESCHREIBUNG_NULLABLE, length=MandantConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for MANDANT.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for MANDANT.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, MandantConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = MandantConstants.NAME_NULLABLE, length=MandantConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for MANDANT.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for MANDANT.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, MandantConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
      @javax.persistence.Column(name = "NUMMER", nullable = MandantConstants.NUMMER_NULLABLE, precision=MandantConstants.NUMMER_PRECISION, scale=MandantConstants.NUMMER_SCALE)
            
  protected java.lang.Long nummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNummer = false;

  public boolean hasChangedNummer(){
    return hasChangedNummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenNummer;
  
  /**
   * 
   *
   * getter for MANDANT.NUMMER
   */
    @Override   public  java.lang.Long getNummer() {
        return nummer;
      }

  /**
   * 
   *
   * setter for MANDANT.NUMMER
   *
   * @param nummer
   */
  @Override   public void setNummer( java.lang.Long nummer) {

       resetTkCache();
                  java.lang.Long nummerInternal = nummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nummer
      , nummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nummer");
      }


             if (!isSeitLadenVeraendertNummer) {
          isSeitLadenVeraendertNummer = thisAttributChanged;
         if (isSeitLadenVeraendertNummer){
           wertNachLadenNummer=this.nummer;
         }
       }
      

       this.nummer = nummerInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = MandantConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.mandant.entity.MandantStatus status =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.mandant.entity.MandantStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for MANDANT.STATUS
   */
    @Override   public  de.ivu.elect.business.mandant.entity.MandantStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for MANDANT.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.mandant.entity.MandantStatus status) {

       resetTkCache();
                  de.ivu.elect.business.mandant.entity.MandantStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "SYSTEM_GEBIETSEBENE", nullable = MandantConstants.SYSTEM_GEBIETSEBENE_NULLABLE)
    
  protected de.ivu.elect.business.system.entity.SystemGebietsebene systemGebietsebene =  de.ivu.elect.business.system.entity.SystemGebietsebene.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedSystemGebietsebene = false;

  public boolean hasChangedSystemGebietsebene(){
    return hasChangedSystemGebietsebene;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSystemGebietsebene = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.system.entity.SystemGebietsebene wertNachLadenSystemGebietsebene;
  
  /**
   * 
   *
   * getter for MANDANT.SYSTEM_GEBIETSEBENE
   */
    @Override   public  de.ivu.elect.business.system.entity.SystemGebietsebene getSystemGebietsebene() {
        return systemGebietsebene;
      }

  /**
   * 
   *
   * setter for MANDANT.SYSTEM_GEBIETSEBENE
   *
   * @param systemGebietsebene
   */
  @Override   public void setSystemGebietsebene( de.ivu.elect.business.system.entity.SystemGebietsebene systemGebietsebene) {

       resetTkCache();
                  de.ivu.elect.business.system.entity.SystemGebietsebene systemGebietsebeneInternal = systemGebietsebene;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.systemGebietsebene
      , systemGebietsebeneInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSystemGebietsebene |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("systemGebietsebene");
      }


             if (!isSeitLadenVeraendertSystemGebietsebene) {
          isSeitLadenVeraendertSystemGebietsebene = thisAttributChanged;
         if (isSeitLadenVeraendertSystemGebietsebene){
           wertNachLadenSystemGebietsebene=this.systemGebietsebene;
         }
       }
      

       this.systemGebietsebene = systemGebietsebeneInternal;

         }

        
  @javax.persistence.Column(name = "VERANTWORTETE_GEBIETE", nullable = MandantConstants.VERANTWORTETE_GEBIETE_NULLABLE, length=MandantConstants.VERANTWORTETE_GEBIETE_MAX_LENGTH)
        
  protected java.lang.String verantworteteGebiete =  null;

  @javax.persistence.Transient
  protected boolean hasChangedVerantworteteGebiete = false;

  public boolean hasChangedVerantworteteGebiete(){
    return hasChangedVerantworteteGebiete;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertVerantworteteGebiete = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenVerantworteteGebiete;
  
  /**
   * 
   *
   * getter for MANDANT.VERANTWORTETE_GEBIETE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getVerantworteteGebiete() {
        return verantworteteGebiete;
      }

  /**
   * 
   *
   * setter for MANDANT.VERANTWORTETE_GEBIETE
   *
   * @param verantworteteGebiete
   */
  @Override   public void setVerantworteteGebiete(@javax.annotation.Nullable  java.lang.String verantworteteGebiete) {

       resetTkCache();
                  
                          java.lang.String verantworteteGebieteInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(verantworteteGebiete, MandantConstants.VERANTWORTETE_GEBIETE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.verantworteteGebiete
      , verantworteteGebieteInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedVerantworteteGebiete |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("verantworteteGebiete");
      }


             if (!isSeitLadenVeraendertVerantworteteGebiete) {
          isSeitLadenVeraendertVerantworteteGebiete = thisAttributChanged;
         if (isSeitLadenVeraendertVerantworteteGebiete){
           wertNachLadenVerantworteteGebiete=this.verantworteteGebiete;
         }
       }
      

       this.verantworteteGebiete = verantworteteGebieteInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Mandant:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Mandant other){
                             other.art = this.art;
                                other.beschreibung = this.beschreibung;
                                other.name = this.name;
                                other.nummer = this.nummer;
                                other.status = this.status;
                                other.systemGebietsebene = this.systemGebietsebene;
                                other.verantworteteGebiete = this.verantworteteGebiete;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Mandant.class)){
        copyEntityAttributesUsingSetter((Mandant) other.castTo(Mandant.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Mandant: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Mandant other){
               other.setArt(this.art);
                  other.setBeschreibung(this.beschreibung);
                  other.setName(this.name);
                  other.setNummer(this.nummer);
                  other.setStatus(this.status);
                  other.setSystemGebietsebene(this.systemGebietsebene);
                  other.setVerantworteteGebiete(this.verantworteteGebiete);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Mandant other){
                       if (hasChangedArt) {
        other.setArt(this.art);
      }
                             if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedNummer) {
        other.setNummer(this.nummer);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedSystemGebietsebene) {
        other.setSystemGebietsebene(this.systemGebietsebene);
      }
                             if (hasChangedVerantworteteGebiete) {
        other.setVerantworteteGebiete(this.verantworteteGebiete);
      }
             }





    @javax.persistence.Transient
    private transient MandantTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public MandantTK getMandantTK(){
    if (tkCache==null) {
    tkCache = new MandantTK(

getNummer()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getMandantTK();
    }

  @Override
  public MandantUK getUk(){
    return getMandantUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Mandant.class;
  }

public MandantUK getMandantUK(){

   return  new MandantUK(

getNummer()


  );
}

  @javax.persistence.Transient
  private transient MandantProperties properties;

  public MandantProperties getProperties(){
    if (properties == null) {
      properties = new MandantProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public MandantProperties getMandantProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return MandantConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_ART_EINZAHL);

        art =
     (de.ivu.elect.business.mandant.entity.MandantArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_NUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_NUMMER_EINZAHL);

        nummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.mandant.entity.MandantStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL);

        systemGebietsebene =
     (de.ivu.elect.business.system.entity.SystemGebietsebene) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(MandantConstants.MESSAGE_KEY_VERANTWORTETE_GEBIETE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(MandantConstants.MESSAGE_KEY_VERANTWORTETE_GEBIETE_EINZAHL);

        verantworteteGebiete =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertArt) {
      result.put(MandantConstants.MESSAGE_KEY_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenArt , art));
    }
                            if (isSeitLadenVeraendertBeschreibung) {
      result.put(MandantConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(MandantConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertNummer) {
      result.put(MandantConstants.MESSAGE_KEY_NUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenNummer , nummer));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(MandantConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertSystemGebietsebene) {
      result.put(MandantConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenSystemGebietsebene , systemGebietsebene));
    }
                            if (isSeitLadenVeraendertVerantworteteGebiete) {
      result.put(MandantConstants.MESSAGE_KEY_VERANTWORTETE_GEBIETE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenVerantworteteGebiete , verantworteteGebiete));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertArt = false;
      wertNachLadenArt = null;
                          isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertNummer = false;
      wertNachLadenNummer = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertSystemGebietsebene = false;
      wertNachLadenSystemGebietsebene = null;
                          isSeitLadenVeraendertVerantworteteGebiete = false;
      wertNachLadenVerantworteteGebiete = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "MANDANT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Mandant";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(art, this, MandantConstants.MESSAGE_KEY_ART_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(MandantConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, MandantConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, MandantConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(MandantConstants.NAME_MAX_LENGTH , 1 ,  name, this, MandantConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nummer, this, MandantConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(MandantConstants.NUMMER_MAX_VALUE, MandantConstants.NUMMER_MIN_VALUE, nummer, this, MandantConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, MandantConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(systemGebietsebene, this, MandantConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(MandantConstants.VERANTWORTETE_GEBIETE_MAX_LENGTH ,  verantworteteGebiete, this, MandantConstants.MESSAGE_KEY_VERANTWORTETE_GEBIETE_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
